enum EXT_FLAGS
{
	EXT_CREATED_NEW_SOURCE  = 1,
	EXT_CREATED_NEW_INCLUDE = 2,
	EXT_SUCCESS             = 4
}

#define ENV_SOURCE_FILE  "SOURCE_FILE"
#define ENV_TARGET_FILE  "TARGET_FILE"
#define ENV_INCLUDE_FILE "INCLUDE_FILE"

#ifndef _extensions_

declare extern SourceExtensions(string *path),EXT_FLAGS;

#else

// private defines for extensions.src
struct CAssoc
{
	CAssoc *next;
	void   *value;
	dstring key[1];
}

class CPointerAssoc2 //: CPointerAssoc
{
	CAssoc *m_list;
	int nStringCount;

	declare Add(string *key, pointer value);
	declare Remove(string *key, BOOL fDelete);
	declare Lookup(string *key), pointer;
	declare RemoveAll(BOOL fDelete);
	declare CPointerAssoc2();
	declare _CPointerAssoc2();
}


class CXX
{
	CTokenizer tok;
	CPointerAssoc2 wstrings;
	CPointerAssoc2 aliases;  // delete=TRUE; list of strings used in TEXT()
	CPointerAssoc2 macros;
	BOOL fFailed;
	BOOL fTryWasUsed;
	BOOL fWstringWasUsed;
	BOOL fChanged;

	declare CXX() {
		fFailed = FALSE;
		fTryWasUsed = FALSE;
		fWstringWasUsed = FALSE;
		fChanged = FALSE;
	}
}

#endif
